// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package chatPrivate

import (
	context "context"
	chat "gitlab.com/fcpartners/apis/gen/chat/v1/chat"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ChatServiceClient is the client API for ChatService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ChatServiceClient interface {
	//------------------------
	// Create chat
	//------------------------
	// Access:
	//   HTTP URL:     <host>:<port>/v0/chat/create
	//   Format: json
	//--------------------------------------------------------------------------------------------------------------------
	Create(ctx context.Context, in *CreateRequest, opts ...grpc.CallOption) (*chat.ServerComMessage, error)
	//------------------------
	// Create chat
	//------------------------
	// Access:
	//   HTTP URL:     <host>:<port>/v0/chat/addMessages
	//   Format: json
	//--------------------------------------------------------------------------------------------------------------------
	AddMessages(ctx context.Context, in *AddMessagesRequest, opts ...grpc.CallOption) (*chat.ServerComMessage, error)
}

type chatServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewChatServiceClient(cc grpc.ClientConnInterface) ChatServiceClient {
	return &chatServiceClient{cc}
}

func (c *chatServiceClient) Create(ctx context.Context, in *CreateRequest, opts ...grpc.CallOption) (*chat.ServerComMessage, error) {
	out := new(chat.ServerComMessage)
	err := c.cc.Invoke(ctx, "/fcp.chat.v1.chat_private.ChatService/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *chatServiceClient) AddMessages(ctx context.Context, in *AddMessagesRequest, opts ...grpc.CallOption) (*chat.ServerComMessage, error) {
	out := new(chat.ServerComMessage)
	err := c.cc.Invoke(ctx, "/fcp.chat.v1.chat_private.ChatService/AddMessages", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ChatServiceServer is the server API for ChatService service.
// All implementations must embed UnimplementedChatServiceServer
// for forward compatibility
type ChatServiceServer interface {
	//------------------------
	// Create chat
	//------------------------
	// Access:
	//   HTTP URL:     <host>:<port>/v0/chat/create
	//   Format: json
	//--------------------------------------------------------------------------------------------------------------------
	Create(context.Context, *CreateRequest) (*chat.ServerComMessage, error)
	//------------------------
	// Create chat
	//------------------------
	// Access:
	//   HTTP URL:     <host>:<port>/v0/chat/addMessages
	//   Format: json
	//--------------------------------------------------------------------------------------------------------------------
	AddMessages(context.Context, *AddMessagesRequest) (*chat.ServerComMessage, error)
	mustEmbedUnimplementedChatServiceServer()
}

// UnimplementedChatServiceServer must be embedded to have forward compatible implementations.
type UnimplementedChatServiceServer struct {
}

func (UnimplementedChatServiceServer) Create(context.Context, *CreateRequest) (*chat.ServerComMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedChatServiceServer) AddMessages(context.Context, *AddMessagesRequest) (*chat.ServerComMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddMessages not implemented")
}
func (UnimplementedChatServiceServer) mustEmbedUnimplementedChatServiceServer() {}

// UnsafeChatServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ChatServiceServer will
// result in compilation errors.
type UnsafeChatServiceServer interface {
	mustEmbedUnimplementedChatServiceServer()
}

func RegisterChatServiceServer(s grpc.ServiceRegistrar, srv ChatServiceServer) {
	s.RegisterService(&ChatService_ServiceDesc, srv)
}

func _ChatService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ChatServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.chat.v1.chat_private.ChatService/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ChatServiceServer).Create(ctx, req.(*CreateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ChatService_AddMessages_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddMessagesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ChatServiceServer).AddMessages(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.chat.v1.chat_private.ChatService/AddMessages",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ChatServiceServer).AddMessages(ctx, req.(*AddMessagesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ChatService_ServiceDesc is the grpc.ServiceDesc for ChatService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ChatService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.chat.v1.chat_private.ChatService",
	HandlerType: (*ChatServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _ChatService_Create_Handler,
		},
		{
			MethodName: "AddMessages",
			Handler:    _ChatService_AddMessages_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/chat_private/chat.proto",
}
